"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.httpProxyAgents = httpProxyAgents;
exports.httpsProxyAgents = httpsProxyAgents;
var _smTunnelAgent = _interopRequireDefault(require("sm-tunnel-agent"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function modifyOpts(options) {
  const proxy = options.proxy;
  if (!proxy.proxyAuth && proxy.auth && proxy.auth.username) {
    proxy.proxyAuth = `${proxy.auth.username}:${proxy.auth.password}`;
  }
}
function httpProxyAgents(options) {
  modifyOpts(options);
  return {
    http: _smTunnelAgent.default.httpOverHttp(options),
    https: _smTunnelAgent.default.httpsOverHttp(options)
  };
}
function httpsProxyAgents(options) {
  modifyOpts(options);
  return {
    http: _smTunnelAgent.default.httpOverHttps(options),
    https: _smTunnelAgent.default.httpsOverHttps(options)
  };
}
//# sourceMappingURL=httpProxyAgent.js.map